namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter14.Listing14_12
{
    using Listing14_01;
    using Listing14_10;

    public class Program
    {
        public static void Main()
        {
            Thermostat thermostat = new Thermostat();
            Heater heater = new Heater(60);
            Cooler cooler = new Cooler(80);

            // Uwaga: jeśli korzystasz z wersji C# 1.0, zastosuj instrukcję
            // new Action (cooler.OnTemperatureChanged).
            thermostat.OnTemperatureChange +=
                heater.OnTemperatureChanged;

            thermostat.OnTemperatureChange +=
                cooler.OnTemperatureChanged;

            // Błąd: powinno być niedozwolone
            thermostat.OnTemperatureChange(42);
        }
    }
}